100  '************************************************************************
200  '*                                                                      *
300  '*   Basterm- A simple terminal emulation program for use with MS-DOS   *
400  '*   =======  and Serial Solutions COM port driver.                     *
500  '*                                                                      *
600  '*                                                                      *
700  '************************************************************************
800  '*                                                                      *
900  '*              Written By Richard Davis 14/6/1990                      *
1000 '*                     Copyright (c) 1990                               *
1100 '*                                                                      *
1200 '************************************************************************
1220 '*                                                                      *
1230 '*   Program runs under GW-BASIC and QuickBASIC 4.5                     *
1240 '*   Note that line 28470 in necessary to GW-BASIC, but will not        *
1250 '*   compile under QuickBASIC. Comment out this line if running under   *
1260 '*   QuickBASIC.                                                        *
1270 '*                                                                      *
1280 '************************************************************************
1300 :
2000 DEFINT A-Z          'Use integers by default
2010 :
2020 ' Definitions for QuickBASIC BIOS interface (GW-BASIC ignores this)
2030 ' $INCLUDE: 'QB.BI'
2040 :
2050 DIM ASM%(23)       'BIOS interface for GW-BASIC
2060 :
2070 'Set main program variables.
2080 :
2090 BUFFER$ = ""       'Hold text for input/output
2100 :
2110 DIM INXLT$(255), OUTXLT$(255)       'Translations
2120 :
2130 COMNAME$ = "COM1"  'Name of serial port
2140 COMNO = 0          '0..15 ==> COM1 to COM16
2150 BAUD = 4           'Baud rate number
2160 PARITY = 2         'Even parity number
2170 DATABITS = 2       '7 bit word length
2180 STOPBITS = 0       '1 stop bit
2190 BRK = 0            'No break
2200 :
2210 'Names of parity settings
2220 PARITYS$ = " none  odd even markspace"
2230 'Name of current Baud rate
2240 BAUD$ = "1200"
2250 'Names of data bits
2260 DATS$ = "5678"
2270 'Names of stop bits
2280 STOPS$ = "12"
2290 :
2300 'Setup menu data structures
2310 DIM OPTIONS$(9)
2320 :
2330 ECHO = 0           'No echo
2340 ECHOS = 1          'Flag for echo to line
2350 ECHOL = 2          'Flag for echo to screen
2360 :
2370 NEXTFILENUM = 2    'Next file for execute file routine to use
2380 :
3000 'Set up key definitions and traps
3010 :
3020 ON KEY(1) GOSUB 17000      'Help on F1
3030 KEY(1) ON
3040 :
3050 ON KEY(2) GOSUB 12000      'Setup on F2
3060 KEY(2) ON
3070 :
3080 ON KEY(10) GOSUB 15000     'Quit on F10
3090 KEY(10) ON
3100 :
3110 KEY 15, CHR$(&H8) + CHR$(&H2E)     'ALT-C
3120 ON KEY(15) GOSUB 14010             'ALT-C is command processor
3130 KEY(15) ON
3140 :
3150 KEY OFF            'Turn off key displays at bottom of screen
3160 :
4000 GOSUB 27000         'Initialise BIOS interface
4010 :
4020 GOSUB 6010          'Initialise translation tables
4030 :
4040 GOSUB 8010          'Open file to serial port
4050 :
4060  :
4070 GOSUB 7010          'Execute definition file
4080 :                                                     
4090 :
5000 '******************************************************************
5010 'Main program
5020 :
5030 WHILE 1             'Repeats forever
5040 :
5050   GOSUB 9010        'Read in characters for port
5060 :
5070   GOSUB 9500        'Read characters/commands from keyboard
5080 :
5090 WEND                'End infinite loop
5100 :
5110 :
5120 END
5130 :
5140 '******************************************************************
5150 'End of main program
5160 :
5170 :
6000 '******************************************************************
6010 'Initialise translation tables
6020 :
6030 FOR I = 0 TO 255           'Each character
6040   INXLT$(I) = CHR$(I)      'initially maps
6050   OUTXLT$(I) = CHR$(I)     'onto itself
6060 NEXT I
6070 :
6080 RETURN
6090 :
6100 :
7000 '******************************************************************
7010 'Execute definitions file.
7020 :
7030 IF COMMAND$ = "" THEN 7160 'Use termdef.txt
7040 :
7050 'Look for file specified on command line. In GW-BASIC set Command$
7060 'explicitly before running BASTERM.
7070 ON ERROR GOTO 7200
7080 OPEN COMMAND$ FOR INPUT AS #2
7090 ON ERROR GOTO 0
7100 :
7110 CLOSE #2
7120 CMD$ = COMMAND$
7130 GOSUB 22010        'Execute file
7140 RETURN
7150 ON ERROR GOTO 0
7160 CMD$ = "Termdef.txt"
7170 GOSUB 22010        'Execute termdef.txt
7180 :
7190 RETURN
7200 'Execute default open error handler
7210 RESUME 7150        'Try termdef.txt
7220 :
7230 :
8000 '******************************************************************
8010 'Open file to serial port
8020 :
8030 OPEN "R", #1, COMNAME$, 1 'Random file, record length=1 byte
8040 FIELD #1, 1 AS P$          'Define P$ as input/output variable
8050 :
8060 RETURN
8070 :
8080 :
9000 '******************************************************************
9010 'Read characters from port, send to screen
9020 :
9030 ON ERROR GOTO 9300
9040 :
9050 GET #1                     'Attempt read
9060 :
9070 IF EOF(1) THEN RETURN      'Eof ==> none read
9080 :
9090 ON ERROR GOTO 0
9100 :
9110 BUFFER$ = P$
9120 :
9130 'If echo to line then send to serial port
9140 IF ECHO AND ECHOL THEN GOSUB 10010
9150 :
9160 'Translate character
9170 BUFFER$ = INXLT$(ASC(BUFFER$))
9180 :
9190 'Output to screen
9200 FOR I = 1 TO LEN(BUFFER$)
9210   IF MID$(BUFFER$, I, 1) = CHR$(10) THEN PRINT : GOTO 9230
9220   PRINT MID$(BUFFER$, I, 1);
9230 NEXT I
9240 :
9250 RETURN
9260 :
9300 'Input error handler
9310 :
9320 RESUME 9340
9330 :
9340 ON ERROR GOTO 0
9350 :
9360 RETURN
9370 :
9380 :
9500 '******************************************************************
9510 'Read characters from keyboard, translate and send to port
9520 :
9530 BUFFER$ = INKEY$
9540 :
9550 'Check if any read
9560 IF BUFFER$ = "" THEN RETURN
9570 :
9580 'Convert CR to internal end of line character
9590 IF ASC(BUFFER$) = 13 THEN BUFFER$ = CHR$(10)
9600 :
9610 'Check echo setting
9620 IF ECHO AND ECHOS THEN PRINT BUFFER$;
9630 :
9640 'Translate output
9650 BUFFER$ = OUTXLT$(ASC(BUFFER$))
9660 :
9670 GOSUB 10010         'Send characters to port
9680 :
9690 RETURN
9700 :
9710 :
10000 '******************************************************************
10010 'Send characters in buffer$ out to port.
10020 :
10030 ON ERROR GOTO 10200
10040 :
10050 FOR I = 1 TO LEN(BUFFER$)
10060   :
10070   LSET P$ = BUFFER$
10080   :
10090   PUT #1
10100   :
10110 NEXT I
10120 :
10130 ON ERROR GOTO 0
10140 :
10150 RETURN
10160 :
10200 'Output error hanldler
10210 :
10220 PRINT "Failed to output characters to port."
10230 :
10240 RESUME NEXT
10250 :
10260 :
11000 '******************************************************************
11010 'Process a command
11020 :
11030 GOSUB 25010               'loose any initial spaces
11040 :
11050 IF CMD$ = "" THEN RETURN  'empty string
11060 :
11070 :
11080 S$ = LEFT$(CMD$, 1)       'Separate off command letter
11090 CMD$ = MID$(CMD$, 2): GOSUB 25010
11100 :
11110 'Convert to lower case
11120 IF S$ >= "A" AND S$ <= "Z" THEN S$ = CHR$(ASC(S$) + 32)
11130 :
11140 IF S$ = "q" THEN 15010    'Quit terminal
11150 IF S$ = "i" THEN 16010    'Set input translation
11160 IF S$ = "o" THEN 16510    'Set output translation
11170 IF S$ = "h" THEN 17010    'Help
11180 IF S$ = "c" THEN 18010    'Set COM port
11190 IF S$ = "b" THEN 19010    'Set Baud rate
11200 IF S$ = "p" THEN 20010    'Set Parity
11210 IF S$ = "d" THEN 21010    'Set data bits
11220 IF S$ = "s" THEN 21510    'Set number stop bits
11230 IF S$ = "x" THEN 22010    'Execute file
11240 IF S$ <> "r" THEN 11300
11250 'Run DOS command
11260 PRINT "Executing DOS command-"; CMD$
11270 SHELL CMD$
11280 PRINT "Returned to BASTERM"
11290 RETURN
11300 IF S$ = "e" THEN 23010    'Set echo
11310 IF S$ = "t" THEN 24010    'Transmit sequence
11320 IF S$ <> "'" THEN 11360
11330 'Comment line-simply echo to screen
11340 PRINT CMD$
11350 RETURN
11360 'Bad command
11370 PRINT "Command not recognised"
11380 :
11390 RETURN
11400 :
11410 :
12000 '******************************************************************
12010 'Setup. Present user with a set of menus to set serial port etc
12020 :
12030 KEY(15) OFF       'Turn off key traps
12040 KEY(1) OFF
12050 KEY(2) OFF
12060 KEY(10) OFF
12070 :
12080 DONE = 0
12090 :
12100 WHILE NOT DONE
12110   GOSUB 13000     'Make main menu
12120   :
12130   GOSUB 13600     'Do main menu
12140   :
12150   IF CHOICE <> 0 THEN 12260
12160     'Set COM port
12170     TITLE$ = " Select Port To Use (Now " + COMNAME$ + ") "
12180     RESTORE 13520
12190     GOSUB 13400           'Set up menu
12200     GOSUB 13600           'Do menu
12210     IF CHOICE = 8 THEN 12850      '8 is leave alone
12220       CMD$ = OPTIONS$(CHOICE)
12230       GOSUB 18010                 'Set COM port
12240       GOTO 12850
12250   :
12260   IF CHOICE <> 1 THEN 12370
12270     'Set Baud rate
12280     TITLE$ = " Select Baud Rate (Now " + BAUD$ + " Baud)"
12290     RESTORE 13530
12300     GOSUB 13400           'Set up menu
12310     GOSUB 13600           'Do menu
12320     IF CHOICE = 8 THEN 12850      '8 is leave alone
12330       CMD$ = OPTIONS$(CHOICE)
12340       GOSUB 19010                 'Set Baud rate
12350       GOTO 12850
12360   :
12370   IF CHOICE <> 2 THEN 12500
12380     'Set parity
12390     CMD$ = MID$(PARITYS$, 5 * PARITY + 1, 5)
12400     GOSUB 25010
12410     TITLE$ = " Select Parity (Now " + CMD$ + ") "
12420     RESTORE 13550
12430     GOSUB 13400           'Set up menu
12440     GOSUB 13600           'Do menu
12450     IF CHOICE = 5 THEN 12850      '5 is leave alone
12460       CMD$ = MID$("noems", CHOICE + 1, 1)
12470       GOSUB 20010         'Set parity
12480       GOTO 12850
12490   :
12500   IF CHOICE <> 3 THEN 12620
12510     'Set word length
12520     TITLE$ = MID$(DATS$, DATABITS + 1, 1)
12530     TITLE$ = " Select Number Data Bits (Now " + TITLE$ + " Bits) "
12540     RESTORE 13560
12550     GOSUB 13400           'Set up menu
12560     GOSUB 13600           'Do menu
12570     IF CHOICE = 4 THEN 12850      '4 is leave alone
12580       CMD$ = OPTIONS$(CHOICE)
12590       GOSUB 21010         'Set data bits
12600       GOTO 12850
12610   :
12620   IF CHOICE <> 4 THEN 12740
12630     'Set number stop bits
12640     TITLE$ = MID$(STOPS$, STOPBITS + 1, 1)
12650     TITLE$ = " Select Number Data Bits (Now " + TITLE$ + " Bits) "
12660     RESTORE 13570
12670     GOSUB 13400           'Set up menu
12680     GOSUB 13600           'Do menu
12690     IF CHOICE = 2 THEN 12850      '2 is leave alone
12700       CMD$ = OPTIONS$(CHOICE)
12710       GOSUB 21510         'Set stop bits
12720       GOTO 12850
12730   :
12740   IF CHOICE <> 5 THEN 12800
12750     'Continue terminal
12760     PRINT "Setup Complete. Returning to terminal session."
12770     DONE = -1
12780     GOTO 12850
12790   :
12800   IF CHOICE <> 6 THEN 12850
12810     'Quit terminal
12820     CMD$ = "q"
12830     GOSUB 11010   'Execute 'q'
12840   :
12850 WEND
12860 :
12870 KEY(15) ON       'Turn key traps back on
12880 KEY(1) ON
12890 KEY(2) ON
12900 KEY(10) ON
12910 :
12920 RETURN
12930 :
12940 :
13000 '******************************************************************
13010 'Generate main menu
13020 :
13030 OPTIONS$(0) = "Port           (Now " + COMNAME$ + " )"
13040 OPTIONS$(1) = "Baud Rate      (Now " + BAUD$ + " )"
13050 CMD$ = MID$(PARITYS$, 5 * PARITY + 1, 5)
13060 GOSUB 25010
13070 OPTIONS$(2) = "Parity         (Now " + CMD$ + " )"
13080 S$ = MID$(DATS$, DATABITS + 1, 1)
13090 OPTIONS$(3) = "No. Data Bits  (Now " + S$ + " )"
13100 S$ = MID$(STOPS$, STOPBITS + 1, 1)
13110 OPTIONS$(4) = "No. Stop Bits  (Now " + S$ + " )"
13120 OPTIONS$(5) = "Continue terminal"
13130 OPTIONS$(6) = "Quit terminal"
13140 OPTIONS$(7) = ""
13150 TITLE$ = " Setup Main Menu "
13160 :
13170 RETURN
13180 :
13190 :
13400 '******************************************************************
13410 'Fill Options$ from data statements
13420 I = 0
13430 READ OPTIONS$(I)
13440 WHILE OPTIONS$(I) <> ""
13450   I = I + 1
13460   READ OPTIONS$(I)
13470 WEND
13480 :
13490 RETURN
13500 :
13510 'Menus for setup
13520 DATA COM1,COM2,COM3,COM4,COM5,COM6,COM7,COM8,Leave alone,
13530 DATA 110 Baud,150 Baud,300 Baud,600 Baud,1200 Baud
13540 DATA 2400 Baud,4800 Baud,9600 Baud,Leave alone,
13550 DATA None,Odd,Even,Mark,Space,Leave alone,
13560 DATA 5 Bits, 6 Bits,7 Bits,8 Bits,Leave alone,
13570 DATA 1 Bits,2 Bits,Leave alone,
13580 :
13590 :
13600 '******************************************************************
13610 'Menu driver for setup
13620 :
13630 PRINT : PRINT
13640 I = INT((80 - LEN(TITLE$)) / 2)
13650 PRINT STRING$(I, "="); TITLE$; STRING$(79 - I - LEN(TITLE$), "=")
13660 :
13670 I = 0: J = 18
13680 WHILE OPTIONS$(I) <> ""
13690   IF LEN(OPTIONS$(I)) > J THEN J = LEN(OPTIONS$(I))
13700   I = I + 1
13710 WEND
13720 :
13730 J = INT((70 - J) / 2)
13740 S$ = SPACE$(J)
13750 PRINT : PRINT S$; "Key    For........"
13760 :
13770 FOR J = 0 TO I - 1
13780   PRINT S$; "<"; J + 1; ">  "; OPTIONS$(J)
13790 NEXT J
13800 :
13810 :
13820 PRINT : PRINT S$; "Select option:";
13830 :
13840 S$ = INKEY$: CHOICE = VAL(S$)
13850 WHILE CHOICE < 1 OR CHOICE > I
13860   S$ = INKEY$: CHOICE = VAL(S$)
13870 WEND
13880 :
13890 PRINT CHOICE
13900 :
13910 CHOICE = CHOICE - 1
13920 :
13930 RETURN
13940 :
13950 :
14000 '******************************************************************
14010 'ALT-C pressed. Read command and process
14020 :
14030 KEY(15) OFF       'Supress any more traps
14040 :
14050 LINE INPUT "Enter command:", CMD$
14060 :
14070 GOSUB 11010       'Process
14080 :
14090 KEY(15) ON        'Can now handle traps
14100 :
14110 RETURN
14120 :
14130 :
15000 '******************************************************************
15010 'Quit terminal
15020 PRINT "Quitting BASTERM";
15030 KEY ON
15040 CLOSE #1                  'Tidy up
15050 END
15060 :
15070 :
16000 '******************************************************************
16010 'Set input translation
16020 :
16030 GOSUB 26000
16040 IF NOT PARSEOK THEN PRINT "Could not understand key string": RETURN
16050 :
16060 IF LEN(OPSEQ$) = 1 THEN 16090
16070 PRINT "Key String must be one character long"
16080 RETURN
16090 T$ = OPSEQ$
16100 IF CMD$ <> "" THEN CMD$ = MID$(CMD$, 2)   'Drop ':'
16110 :
16120 GOSUB 26000
16130 IF PARSEOK THEN 16160
16140 PRINT "Could not understand replacement string"
16150 RETURN
16160 INXLT$(ASC(T$)) = OPSEQ$
16170 PRINT "Setting input translation from "; T$; " to "; OPSEQ$
16180 RETURN
16190 :
16200 :
16500 '******************************************************************
16510 'Set output translation
16520 :
16530 GOSUB 26000
16540 IF NOT PARSEOK THEN PRINT "Could not understand key string": RETURN
16550 :
16560 IF LEN(OPSEQ$) = 1 THEN 16590
16570 PRINT "Key String must be one character long"
16580 RETURN
16590 T$ = OPSEQ$
16600 IF CMD$ <> "" THEN CMD$ = MID$(CMD$, 2)   'Drop ':'
16610 :
16620 GOSUB 26000
16630 IF PARSEOK THEN 16660
16640 PRINT "Could not understand replacement string"
16650 RETURN
16660 OUTXLT$(ASC(T$)) = OPSEQ$
16670 PRINT "Setting output translation from "; T$; " to "; OPSEQ$
16680 RETURN
16690 :
16700 :
17000 '******************************************************************
17010 'Help routine-prints help information
17020 PRINT "Function keys:"
17030 PRINT "  F1             Help                  ";
17040 PRINT "  F10            Quit                  "
17050 PRINT "  F2             Setup                 "
17060 PRINT "Type ALT-C (Ie press 'C' while 'alt' ke";
17070 PRINT "y is held down to issue command.       "
17080 PRINT "Commands are:                          "
17090 PRINT "  H              help                  ";
17100 PRINT "  Q              quit                  "
17110 PRINT "  E{n|s|l|ls}    set echo screen, line ";
17120 PRINT "  C<portname>    set port (e.g COM2)   "
17130 PRINT "  B<Baudrate>    set Baud rate         ";
17140 PRINT "  P{n|o|e|m|s}   set parity            "
17150 PRINT "  I<char>:<strn> translate input       ";
17160 PRINT "  O<char>:<strn> translate output      "
17170 PRINT "  X<filename>    execute file          ";
17180 PRINT "  R<Command...>  run DOS command       "
17190 PRINT "  T<strn>        transmit sequence     ";
17200 PRINT "  '              Comment               "
17210 PRINT "  ( <char> is a decimal number or a cha";
17220 PRINT "racter in quotation marks.             "
17230 PRINT "    <strn> is a sequence of numbers & q";
17240 PRINT "uoted strings separated by commas,     "
17250 PRINT "    Eg   O 12:12,'New page',13,10      ";
17260 PRINT "                                   )   ";
17270 PRINT
17280 RETURN
17290 :
17300 :
18000 '******************************************************************
18010 'Set COM port
18020 :
18030 IF CMD$ = "" THEN RETURN
18040 :
18050 I = INSTR(CMD$, " ")      'Find end of name
18060 IF I <> 0 THEN CMD$ = LEFT$(CMD$, I - 1)
18070 'Set Cmd$ to upper case
18080 FOR I = 1 TO LEN(CMD$)
18090   S = ASC(MID$(CMD$, I, 1))
18100   IF S >= 97 AND S <= 122 THEN MID$(CMD$, I, 1) = CHR$(S - 32)
18110 NEXT I
18120 COMNAME$ = CMD$
18130 CLOSE #1
18140 GOSUB 8010        'Open port again
18150 IF LEFT$(CMD$, 3) <> "COM" THEN COMNO = -1: GOTO 18240
18160 COMNO = VAL(MID$(CMD$, 4))        'Generate COM port number
18170 :
18180 CMD$ = STR$(COMNO)        'Check that number was last part
18190 GOSUB 25010               'of name
18200 CMD$ = "COM" + CMD$
18210 IF CMD$ <> COMNAME$ THEN COMNO = -1
18220 IF COMNO > 16 OR COMNO < 1 THEN COMNO = -1
18230 COMNO = COMNO - 1
18240 PRINT "Port is "; COMNAME$;
18250 RETURN
18260 :
18270 :
19000 '******************************************************************
19010 'Set Baud rate
19020 :
19030 IF CMD$ = "" THEN PRINT "Baud rate is "; BAUD$: RETURN
19040 :
19050 I = INSTR(CMD$, " ")      'Find end of Baud rate
19060 IF I <> 0 THEN CMD$ = LEFT$(CMD$, I - 1)
19070 :
19080 RESTORE 19510
19090 READ PREFB
19100 WHILE PREFB <> -1
19110   READ TMP$
19120   S$ = TMP$
19130   WHILE TMP$ <> ""
19140     IF TMP$ = CMD$ THEN 19210
19150     READ TMP$
19160   WEND
19170   READ PREFB
19180 WEND
19190 PRINT "Cannot set that baud rate"
19200 RETURN
19210 BAUD = PREFB
19220 BAUD$ = S$
19230 GOSUB 28010
19240 IF NOT INITOK THEN 19190
19250 PRINT "Set Baud rate to "; BAUD$
19260 RETURN
19270 :
19500 'Prefered baud rates and their synonymns
19510 DATA 0,110,11,,1,150,15,,2,300,30,,3,600,60,
19520 DATA 4,1200,120,12,,5,2400,240,24,,6,4800,480,48,
19530 DATA 7,9600,960,96,,8,19200,1920,192,19,
19540 DATA 9,38400,3840,384,38,
19550 DATA 10,56000,5600,560,56,57600,5760,576,57,
19560 DATA 11,115200,11520,1152,115,,-1
19570 :
19580 :
20000 '******************************************************************
20010 'Set Parity
20020 :
20030 IF CMD$ = "" THEN PRINT "Parity is "; PARITY$: RETURN
20040 :
20050 TMPPARAM = PARITY
20060 PARITY = (INSTR("NnOoEeMmSs", LEFT$(CMD$, 1)) - 1) \ 2
20070 PRINT "Attempting to set parity to "; PARITY
20080 GOSUB 28010
20090 IF NOT INITOK THEN 20130
20100 PRINT
20110 PRINT "Set parity to "; MID$(PARITYS$, PARITY * 5 + 1, 5)
20120 RETURN
20130 :
20140 PRINT "Cannot set that parity."
20150 PARITY = TMPPARAM         'Reset parity
20160 RETURN
20170 :
20180 :
20520 :
21000 '******************************************************************
21010 'Set word length
21020 :
21030 IF CMD$ = "" THEN RETURN
21040 :
21050 TMPPARAM = DATABITS       'Save old number
21060 :
21070 DATABITS = VAL(CMD$) - 5
21080 GOSUB 28010               'Attempt to set
21090 IF INITOK THEN 21130
21100 PRINT "Cannot set that number data bits"
21110 DATABITS = TMPPARAM       'Restore old number
21120 RETURN
21130 PRINT "Set number data bits to "; MID$(DATS$, DATABITS + 1, 1)
21140 RETURN
21150 :
21160 :
21500 '******************************************************************
21510 'Set number stop bits
21520 :
21530 IF CMD$ = "" THEN RETURN
21540 :
21550 TMPPARAM = STOPBITS       'Save old number
21560 :
21570 STOPBITS = VAL(CMD$) - 1
21580 GOSUB 28010               'Attempt to set
21590 IF INITOK THEN 21630
21600 PRINT "Cannot set that number stop bits"
21610 STOPBITS = TMPPARAM       'Restore old number
21620 RETURN
21630 PRINT "Set number Stop bits to "; MID$(STOPS$, STOPBITS + 1, 1)
21640 RETURN
21650 :
21660 :
22000 '******************************************************************
22010 'Execute file as commands
22020 :
22030 ON ERROR GOTO 22210
22040 :
22050 OPEN CMD$ FOR INPUT AS #NEXTFILENUM
22060 :
22070 ON ERROR GOTO 0
22080 :
22090 PRINT "Executing file-"; CMD$
22100 :
22110 WHILE NOT EOF(NEXTFILENUM)
22120   LINE INPUT #NEXTFILENUM, CMD$
22130   NEXTFILENUM = NEXTFILENUM + 1     'For nested calls
22140   GOSUB 11010                       'Process command
22150   NEXTFILENUM = NEXTFILENUM - 1
22160 WEND
22170 CLOSE #NEXTFILENUM
22180 PRINT "Returned to BASTERM"
22190 ON ERROR GOTO 0
22200 RETURN
22210 'Execute file open error handler
22220 PRINT "Could not open file "; CMD$
22230 RESUME 22190
22240 :
22250 :
23000 '******************************************************************
23010 'Set echo
23020 :
23030 ECHO = 0
23040 :
23050 WHILE CMD$ <> ""
23060   S$ = LEFT$(CMD$, 1)
23070   CMD$ = MID$(CMD$, 2)
23080   IF S$ = " " THEN 23130
23090   IF S$ = "n" OR S$ = "N" THEN ECHO = 0: GOTO 23130
23100   IF S$ = "l" OR S$ = "L" THEN ECHO = ECHO OR ECHOL: GOTO 23130
23110   IF S$ = "s" OR S$ = "S" THEN ECHO = ECHO OR ECHOS: GOTO 23130
23120   PRINT "Unrecognised character ("; S$; ") ignored"
23130 WEND
23140 :
23150 RESTORE 23240
23160 FOR I = 0 TO ECHO
23170  READ S$
23180 NEXT I
23190 :
23200 PRINT "Setting echo to "; S$
23210 :
23220 RETURN
23230 :
23240 DATA "no echo","echo to screen only"
23250 DATA "echo to line only","echo to both screen and line"
23260 :
23270 :
24000 '******************************************************************
24010 'Tranmit sequence
24020 'Parameter is a <string_def> of form of line 26000
24030 :
24040 GOSUB 26000
24050 IF PARSEOK AND CMD$ = "" THEN 24080
24060 PRINT "Cannot understand string to transmit"
24070 RETURN
24080 BUFFER$ = OPSEQ$
24090 PRINT "Transmitting "; BUFFER$
24100 GOSUB 10010
24110 :
24120 RETURN
24130 :
24140 :
25000 '******************************************************************
25010 'Drop leading space from Cmd$
25020 :
25030 WHILE LEFT$(CMD$, 1) = " "
25040  :
25050  CMD$ = MID$(CMD$, 2)
25060  :
25070 WEND
25080 :
25090 RETURN
25100 :
25110 :
26000 '******************************************************************
26010 'Parse a string definition in Cmd$
26020 'Definition is of form
26030 '   <string_def>={|<Quoted_string>|<char_def>}[,<string_def>]
26040 'String must be terminated by ':' or the end of Cmd$.
26050 'Parseok is a flag, true if the parse was successful.
26060 'opseq$ is the resulting string
26070 :
26080 OPSEQ$ = ""
26090 GOSUB 25010
26100 PARSEOK = -1
26110 WHILE CMD$ <> "" AND LEFT$(CMD$, 1) <> ":"
26120   PARSEOK = 0
26130   GOSUB 25010
26140   IF NOT (LEFT$(CMD$, 1) = "'" OR LEFT$(CMD$, 1) = CHR$(34)) THEN 26250
26150     'Is a quoted string
26160     S$ = LEFT$(CMD$, 1)
26170     CMD$ = MID$(CMD$, 2)
26180     WHILE CMD$ <> "" AND LEFT$(CMD$, 1) <> S$
26190       OPSEQ$ = OPSEQ$ + LEFT$(CMD$, 1)
26200       CMD$ = MID$(CMD$, 2)
26210     WEND
26220     IF CMD$ = "" THEN 26460 'no closing quote
26230     CMD$ = MID$(CMD$, 2)
26240     GOTO 26360
26250   IF INSTR("0123456789", LEFT$(CMD$, 1)) = 0 THEN 26360
26260     'Is a number
26270     I = 1
26280     IF I > LEN(CMD$) THEN 26320
26290     IF INSTR("0123456789", MID$(CMD$, I, 1)) = 0 THEN 26320
26300     I = I + 1
26310     GOTO 26280
26320     J = VAL(LEFT$(CMD$, I - 1))
26330     CMD$ = MID$(CMD$, I)
26340     IF J < 0 OR J > 255 THEN 26460 'Number out of range
26350     OPSEQ$ = OPSEQ$ + CHR$(J)
26360   GOSUB 25010
26370   IF CMD$ = "" THEN 26400
26380     IF LEFT$(CMD$, 1) = "," THEN CMD$ = MID$(CMD$, 2): GOTO 26400
26390     IF LEFT$(CMD$, 1) <> ":" THEN 26460  'Bad sepatator
26400   PARSEOK = -1
26410 WEND
26420 :
26430 RETURN
26440 :
26450 :
26460 'Exit loop neatly
26470 CMD$ = ""
26480 GOTO 26410
26485 :
27000 'Set up BIOS interface. Depends on whether this is running under
27010 'QuickBASIC 4.5 or GW-BASIC/BASICA
27020 :
27030 ON ERROR GOTO 27150
27040 :
27050 'This line will generate an error under GW-BASIC/BASICA- trapped
27060 DIM INREGS AS REGTYPE, OUTREGS AS REGTYPE
27070 :
27080 ISBASICA = 0      'This is QuickBASIC 4.5
27090 :
27100 ON ERROR GOTO 0
27110 IF ISBASICA THEN GOSUB 27310      'Additional setup
27120 :
27130 RETURN
27140 :
27150 'Error has occured- means that this is GW-BASIC/BASICA
27160 ISBASICA = -1     'This is GW-BASIC
27170 RESUME 27100
27180 :
27190 :
27300 '******************************************************************
27310 'Set up BIOS interface for GW-BASIC, machine code in array ASM%
27320 :
27330 TOT# = 0          'Data check
27340 RESTORE 27520
27350 :
27360 FOR I = 0 TO 21
27370   READ S$, T$                   'read in data
27380   ASM%(I) = VAL("&H" + T$ + S$)
27390   TOT# = TOT# + ASM%(I)
27400 NEXT I
27410 :
27420 IF TOT# = -144845! THEN 27470
27430 PRINT "Bad machine code data, terminating program."
27440 PRINT "Check data statements at lines 27520 to 27710"
27450 END
27460 :
27470 RETURN
27480 :
27500 '8086 machine code. Moves values in operands to chip registers,
27510 'performs INT 14H, and copies the registers back to the variables.
27520 DATA 55                  : 'PUSH BP
27530 DATA 8B,EC               : 'MOV BP,SP
27540 DATA 8B,76,0C            : 'MOV SI,[BP]+0CH
27550 DATA 8B,04               : 'MOV AX,[SI]
27560 DATA 8B,76,0A            : 'MOV SI,[BP]+0AH
27570 DATA 8B,1C               : 'MOV BX,[SI]
27580 DATA 8B,76,08            : 'MOV SI,[BP]+8
27590 DATA 8B,0C               : 'MOV CX,[SI]
27600 DATA 8B,7E,06            : 'MOV DI,[BP]+6
27610 DATA 8B,15               : 'MOV DX,[DI]
27620 DATA CD,14               : 'INT 14h
27630 DATA 89,15               : 'MOV [DI],DX
27640 DATA 89,0C               : 'MOV [SI],CX
27650 DATA 8B,76,0A            : 'MOV SI,[BP]+0AH
27660 DATA 89,1C               : 'MOV [si]+8,BX
27670 DATA 8B,76,0C            : 'MOV SI,[BP]+0CH
27680 DATA 89,04               : 'MOV [si]+6,AX
27690 DATA 5D                  : 'POP BP
27700 DATA CA,08,00            : 'RETF 8
27710 DATA 00
27720 :
27730 :
28000 '******************************************************************
28010 'Set mode of com port-.
28020 'In QuickBASIC 4.5 uses 'call interrupt' to access BIOS
28030 'In GW-BASIC uses small machine code routine
28040 INITOK = 0
28050 'Check parameters are ok first
28060 IF COMNO < 0 OR COMNO > 15 THEN RETURN
28070 INREGS.DX = COMNO
28080 IF BRK < 0 OR BRK > 1 THEN RETURN
28090 INREGS.AX = &H400 OR BRK      '&H04 ==> service 4, extended init
28100 IF PARITY < 0 OR PARITY > 4 THEN RETURN
28110 IF STOPBITS < 0 OR STOPBITS > 1 THEN RETURN
28120 INREGS.BX = PARITY * 256 + STOPBITS
28130 IF DATABITS < 0 OR DATABITS > 3 THEN RETURN
28140 IF BAUD < 0 OR BAUD > 11 THEN RETURN
28150 INREGS.CX = DATABITS * 256 + BAUD
28160 :
28170 INITOK = -1       'All parameters are ok
28180 IF ISBASICA THEN GOSUB 28410 ELSE GOSUB 28610
28190 :
28200 RETURN
28210 :
28220 :
28400 '******************************************************************
28410 'Call BIOS via machine code interface. GW-BASIC
28420 :
28430 DEF SEG
28440 ADDR = VARPTR(ASM%(0))
28450 'Use the following here line in GW-BASIC. It is commented out as
28460 'QuickBASIC refuses to compile it.
28470 'CALL ADDR(INREGS.AX, INREGS.BX, INREGS.CX, INREGS.DX): RETURN
28480 :
28490 PRINT "This is GW-BASIC, remember to uncomment line 28470"
28500 END
28510 :
28600 '******************************************************************
28610 'Call BIOS via statement call interrupt. QuickBASIC 4.5
28620 :
28630 CALL INTERRUPT(&H14, INREGS, OUTREGS)
28640 :
28650 RETURN
28660 :
28670 :
29000 '******************************************************************
29010 'Set mode of com port-use DOS command NewMode.
29020 'Alternative to using BIOS. Uses a command supplied as part of
29030 'serial solutions software, NewMODE, to set parameters
29040 'Note that BASIC cannot tell whether the NewMODE command
29050 'was successful or not. This method works for either GW-BASIC or
29055 'QuickBASIC
29060 :
29070 IF COMNO >= 0 AND COMNO <= 15 THEN 29100
29080 INITOK = 0        '-1 ==> not a COM port
29090 RETURN
29100 NEWM$ = "newmode " + COMNAME$ + ":"
29110 NEWM$ = NEWM$ + BAUD$ + ","
29120 CMD$ = MID$(PARITYS$, 5 * PARITY + 1, 5): GOSUB 25010
29130 NEWM$ = NEWM$ + LEFT$(CMD$, 1) + ","
29140 NEWM$ = NEWM$ + MID$(DATS$, DATABITS + 1, 1) + ","
29150 NEWM$ = NEWM$ + MID$(STOPS$, STOPBITS + 1, 1)
29160 :
29170 PRINT NEWM$
29180 SHELL NEWM$
29190 :
29200 INITOK = -1
29210 RETURN

