C *********************************************************************
C *								      *
C *	FORterm -A simple terminal emulation program for use with     *
C *	=======  MS-DOS and Serial Solutions serial port device       *
C *		 device driver NewCOM.				      *
C *								      *
C *								      *
C *********************************************************************
C *								      *
C *	      Written by  Richard Davis, 22/6/1990		      *
C *								      *
C *		    Copyright (c) 1990				      *
C *								      *
C *								      *
C *********************************************************************
C *								      *
C *	 first command definition module			      *
C *								      *
C *********************************************************************

C Uncomment the following line to include extra error checking code
C     $DEBUG
$DECLARE

C Interface to library function for invoking a DOS shell
      interface to function system( command)
      integer*2 system [far,C,alias:"_system"]
      character*(*) command [far,reference]
      end

C #######################################################
C
C     Interface to second command functions module (FT3)
C
      interface to subroutine setxlt (xlt, xltpt, params)
      character*1024 xlt
      integer xltpt(0:256)
      character*256 params
      end

      interface to subroutine set_com( name )
      character*256 name
      end

      interface to subroutine help
      end

      interface to subroutine set_parity( param )
      character*256 param
      end

      interface to subroutine set_echo ( param )
      character*256 param
      end

      interface to subroutine set_baud(param)
      character*256 param
      end

      interface to subroutine exec_file(name)
      character*256 name
      end





C #######################################################
C
C     Interface to support functions module (FT4)
C

      interface to function kbdinp (c, kbretry)
      logical kbdinp
      character c
      logical kbretry
      end

      interface to subroutine screen (str, source)
      character*(*) str
      integer source
      end

      interface to subroutine dropspace (str)
      character *256 str
      end

      interface to subroutine screscstr (str, num, source)
      character*256 str
      integer num, source
      end

      interface to logical function
     +	BIOS_x_init(port, brk, par, stop, data, Baud)
      integer*1 port, brk, par, stop, data, Baud
      end

      interface to character function tolower (c)
      character c
      end

      interface to logical function parse_str_def (str, opseq ,num)
      integer num
      character *256 str, opseq
      end

      interface to logical function is_digit (str)
      character str
      end


C #######################################################


C *********************************************************************
C *                                                                   *
C *                                                                   *
C *   Setup-Generate a series of menus to set Baud rate etc.          *
C *                                                                   *
C *                                                                   *
C *********************************************************************
      subroutine setup

      integer sumenu
C Port parameters definition common data
      integer*1 comno,baud,parity,databits,stopbits,brk
      common /port/ comno,baud,parity,databits,stopbits,brk
C Port name
      character*8 comname
      common /port/ comname

      character*5 parys(0:4)
      common /parysc/ parys

      integer bauds(0:11)
      common /baudsc/ bauds

      character*16 mainname /'Setup Main Menu'C/
      character*80 portmn(0:8) /'COM1'C,'COM2'C,'COM3'C,'COM4'C,
     +                          'COM5'C,'COM6'C,'COM7'C,'COM8'C,
     +                          'Leave alone'C/
      character*80 baudmn(0:8) /'110 Baud'C,'150 Baud'C,'300 Baud'C,
     +                          '600 Baud'C,'1200 Baud'C,'2400 Baud'C,
     +                          '4800 Baud'C,'9600 Baud'C,
     +                          'Leave alone'C/
      character*80 parmn(0:8)  /'None'C,'Odd'C,'Even'C,'Mark'C,
     +                          'Space'C,'Leave alone'C,''C,''C,''C/
      character*80 dabmn(0:8)  /'5 Bits'C,'6 Bits'C,'7 Bits'C,'8 Bits'C,
     +                          'Leave alone'C,''C,''C,''C,''C/
      character*80 stomn(0:8)  /'1 Bit'C,'2 Bits'C,'Leave alone'C,
     +                          ''C,''C,''C,''C,''C,''C/

      character*80 opts(0:8)
      character*256 tmp
      integer choice

      do while(.TRUE.)

        call sumain (opts)

        choice = sumenu(mainname,opts)

        select case( choice )
C         Set COM port
          case(0)
            tmp = 'Select Port to Use (Now '//comname//' )'C
            choice = sumenu( tmp, portmn)
            if( choice .NE. 8 )then
              tmp = portmn(choice)
              call set_com(tmp)
            end if
C         Set Baud rate
          case(1)
            write(tmp,'(A,I6,A)')
     +         'Select Baud Rate to Use (Now ',bauds(baud),' )'C
            choice = sumenu( tmp, baudmn)
            if( choice .NE. 8 )then
              tmp = baudmn(choice)
              call set_baud(tmp)
            end if
C         Set Parity
          case(2)
            tmp = 'Select Parity to Use (Now '//parys(parity)//' )'C
            choice = sumenu( tmp, parmn)
            if( choice .NE. 5 )then
              tmp = parmn(choice)
              call set_parity(tmp)
            end if
C         Set number data bits
          case(3)
            write(tmp,'(A,I1,A)')
     +             'Select Number Data Bits to Use (Now ',
     +             databits+5,' )'C
            choice = sumenu( tmp, dabmn)
            if( choice .NE. 4 )then
              write(tmp,'(I1,A)') choice+5,char(0)
              call set_databits(tmp)
            end if
C         Set number stop bits
          case(4)
            write(tmp,'(A,I1,A)')
     +             'Select Number Stop Bits to Use (Now ',
     +             stopbits+1,' )'C
            choice = sumenu( tmp, stomn)
            if( choice .NE. 2 )then
              write(tmp,'(I1,A)') choice+1,char(0)
              call set_stopbits(tmp)
            end if
C         Continue terminal
          case(5)
            call screen(
     +        'Setup complete. Returning to terminal session\n'C,2)
            return
C         Quit terminal
          case(6)
            tmp = 'q'C
            call cmdout(tmp)
        end select

      end do
      end

C *********************************************************************
C *                                                                   *
C *                                                                   *
C *  Sumain- Generate text for main menu                              *
C *                                                                   *
C *                                                                   *
C *********************************************************************
      subroutine sumain ( menu )
      character*80 menu(0:8)

C Port parameters definition common data
      integer*1 comno,baud,parity,databits,stopbits,brk
      common /port/ comno,baud,parity,databits,stopbits,brk
C Port name
      character*8 comname
      common /port/ comname

      character*5 parys(0:4)
      common /parysc/ parys

      integer bauds(0:11)
      common /baudsc/ bauds

      menu(0) = 'Port          (now '//comname//' )'C
      write(menu(1),'(A,I6,A)')
     +          'Baud rate     (now ',Bauds(baud),' )'C

      menu(2) = 'Parity        (now '//parys(parity)//' )'C
      write(menu(3),'(A,I1,A)')
     +          'No. data bits (now ',databits+5,' )'C
      write(menu(4),'(A,I1,A)')
     +          'No. stop bits (now ',stopbits+1,' )'C
      menu(5) = 'Continue terminal'C
      menu(6) = 'Quit terminal'C
      menu(7) = ''C
      menu(8) = ''C

      end


C *********************************************************************
C *                                                                   *
C *                                                                   *
C *   SuMenu- Generate a menu from parameters. These are the title    *
C *   and an array of options to pick from.                           *
C *                                                                   *
C *                                                                   *
C *********************************************************************
      function sumenu (title, options)
      integer sumenu
      character*256 title
      character*80 options(0:8)

      logical kbdinp

      integer size, i, number
      character*40 indent
      character c,tmp
      logical dummy

C  Print out title, centered and padded with '='s
      number = scan(title,char(0)) - 1
      size = nint( (80 - number) / 2)
      call screen('\n'C,2)
      do i=1, size
        call screen('='C,2)
      end do
      call screen(title,2)
      do i=(size + number + 1), 80
        call screen('='C,2)
      end do

C     Find largest options and total number options
      number = 0
      size = 12

      do while( (number .LE. 8) .AND.
     +          (scan(options(number),char(0)) .GT. 1) )
        if( scan(options(number),char(0)) .GT. size )then
          size = scan(options(number),char(0))
        end if
        number = number + 1
      end do

C     Size of indent
      size = nint( (70-size)/2 )
      do i=1,size
        indent(i:i) = ' '
      end do
      indent(i:i) = char(0)
      call screen('\n'C,2)
      call screen(indent,2)
      call screen('Key  For.....\n'C,2)

      do i=0,number-1
        write(tmp,'(I1)') i + 1
        call screen(indent,2)
        call screen('<'//tmp//'>  '//options(i),2)
        call screen('\n'C,2)
      end do

      call screen('\n'C,2)
      call screen(indent,2)
      call screen(' Select option:'C,2)

      dummy = kbdinp(c ,.TRUE.)
      do while( (c .LT. '1') .OR.
     +          (c .GT. tmp)       )
        dummy = kbdinp(c ,.TRUE.)
      end do

      call screen(c//'\n'C,2)
      sumenu = ichar(c)-ichar('1')

      end

C *********************************************************************
C *                                                                   *
C *  Cmdout-decode a character string as a command. Commands are      *
C *  single characters (case ignored) followed by optional parameters *
C *  They are nul-terminated.					      *
C *                                                                   *
C *********************************************************************
      subroutine cmdout (cmd)
      character*256 cmd
      character tolower
      integer*2 system

C Translations common data
      character *1024 inxlt, outxlt
      integer inxltpt(0:256), outxltpt(0:256)
      common /translates/ inxlt, outxlt, inxltpt, outxltpt

      character c

      call dropspace(cmd)
      c=cmd(1:1)

      cmd=cmd(2:)
      call dropspace(cmd)
      select case( tolower(c) )
C	Quit program
	case('q')
	  call screen('Quitting program \n'C,2)
	  close (1)
	  stop
C	Set input translation
	case('i')
	  call screen('Setting input translation\n'C,2)
	  call setxlt( inxlt, inxltpt, cmd)
C	Set output translation
	case('o')
	  call screen('Setting output translation\n'C,2)
	  call setxlt( outxlt, outxltpt, cmd )
C	Help
	case('h')
	  call help
C	Set COM port
	case('c')
	  call set_com(cmd)
C	Set Baud rate
        case('b')
	  call set_baud(cmd)
C	Set Parity
	case('p')
	  call set_parity(cmd)
C	Set number data bits
	case('d')
	  call set_databits(cmd)
C	Set number stop bits
	case('s')
	  call set_stopbits(cmd)
C	Execute file of commands
	case('x')
	  call exec_file(cmd)
C       Run DOS command. Note that FORTRAN does not have a shell command
        case('r')
c          call screen('Enter DOS comand at prompt,\n'C,2)
c          call screen('or ''COMMAND''to enter DOS shell.\n'C,2)
c          call screen('Use command ''EXIT'' to return to terminal\n'C,2)
c          pause ' '
          call screen('Executing DOS command-'//cmd,2)
          call screen('\n'C,2)
          if( system(cmd) .EQ. -1 )then
            call screen('Failed to execute command\n'C,2)
          end if
          call screen('Returning to terminal\n'C,2)
C	Set echo
	case('e')
	  call set_echo(cmd)
C       Transmit sequence
        case('t')
          call transmit(cmd)

C       nul string -ignore
        case(''C)
C	Comment marker (single quote mark)
	case('''')
	  call screen(cmd,2)
	  call screen('\n'C,2)
C	Not a command
	case default
	  call screen('Command not recognised\n'C,2)
      end select
      end

C *********************************************************************
C *                                                                   *
C *                                                                   *
C *  Transmit- read parameter for a string definition of same form as *
C *  for translations. Send to serial port without translating        *
C *                                                                   *
C *                                                                   *
C *********************************************************************
      subroutine transmit (tns)
      character*256 tns


      character*256 op
      integer length

      logical parse_str_def

      if( parse_str_def(tns, op, length) )then
        if( tns(1:1) .EQ. char(0) )then
          if( length .GT. 0 )then
            call outstr(op, length)
            call screen('Sent sequence:'C,2)
            call screscstr(op,length,2)
            call screen('\n'C,2)
          else
            call screen('Sent no characters\n'C,2)
          end if
          return
        end if
      end if

      call screen('Could not decode transmit sequence\n'C,2)

      end

C *********************************************************************
C *								      *
C *   Set_databits - reads parameter for a 5,6,7 or 8 digit.	      *
C *   uses this as new word length.				      *
C *								      *
C *********************************************************************
      subroutine set_databits( param )
      character*256 param
C Port parameters definition common data
      integer*1 comno,baud,parity,databits,stopbits,brk
      common /port/ comno,baud,parity,databits,stopbits,brk
C Port name
      character*8 comname
      common /port/ comname

      logical BIOS_x_init

      integer*1 d
      character tmp
      integer io

      if( param(1:1) .NE. char(0) )then
	read(param,'(I1)',iostat=io) d
	param = param(2:)
	call dropspace(param)
	if( (d .GE. 5) .AND.
     +	    (d .LE. 8) .AND.
     +	    (io .EQ. 0) .AND.
     +	    (param(1:1) .EQ. char(0))	)then
          d = d - 5
	  if(BIOS_x_init(comno,brk,parity,stopbits,d,baud))then
	    databits = d
	    write(tmp,'(I1)') databits + 5
	    call screen('Set number data bits to '//tmp//'\n'C,2)
	  else
	    call screen('Cannot set that number of data bits\n'C,2)
	  end if
	else
	  call screen('Bad data bits specification\n'C,2)
	end if
      else
	write(tmp,'(I1)') databits + 5
	call screen('Number data bits is '//tmp//'\n'C,2)
      end if
      end

C *********************************************************************
C *								      *
C *   Set_stopbits - reads parameter for a 1 or 2 digit.	      *
C *   uses this as new number stop bits                               *
C *								      *
C *********************************************************************
      subroutine set_stopbits( param )
      character*256 param
C Port parameters definition common data
      integer*1 comno,baud,parity,databits,stopbits,brk
      common /port/ comno,baud,parity,databits,stopbits,brk
C Port name
      character*8 comname
      common /port/ comname

      logical BIOS_x_init

      integer*1 s
      character tmp
      integer io

      if( param(1:1) .NE. char(0) )then
	read(param,'(I1)',iostat=io) s
	param = param(2:)
	call dropspace(param)
	if( (s .GE. 1) .AND.
     +	    (s .LE. 2) .AND.
     +	    (io .EQ. 0) .AND.
     +	    (param(1:1) .EQ. char(0))	)then
          s = s - 1
	  if(BIOS_x_init(comno,brk,parity,s,databits,baud))then
	    stopbits = s
	    write(tmp,'(I1)') stopbits + 1
	    call screen('Set number stop bits to '//tmp//'\n'C,2)
	  else
	    call screen('Cannot set that number of stop bits\n'C,2)
	  end if
	else
	  call screen('Bad stop bits specification\n'C,2)
	end if
      else
	write(tmp,'(I1)') stopbits + 1
	call screen('Number stop bits is '//tmp//'\n'C,2)
      end if
      end
