C *********************************************************************
C *								      *
C *	FORterm -A simple terminal emulation program for use with     *
C *	=======  MS-DOS and Serial Solutions serial port device       *
C *		 device driver NewCOM.				      *
C *								      *
C *								      *
C *********************************************************************
C *								      *
C *	      Written by  Richard Davis, 22/6/1990		      *
C *								      *
C *		    Copyright (c) 1990				      *
C *								      *
C *								      *
C *********************************************************************
C *								      *
C *	 Second command definition module			      *
C *								      *
C *********************************************************************

C     $DEBUG
$DECLARE

C #######################################################
C
C     Interface to support functions module
C

      interface to subroutine screen (str, source)
      character*(*) str
      integer source
      end

      interface to subroutine dropspace (str)
      character *256 str
      end

      interface to subroutine screscstr (str, num, source)
      character*256 str
      integer num, source
      end

      interface to logical function
     +	BIOS_x_init(port, brk, par, stop, data, Baud)
      integer*1 port, brk, par, stop, data, Baud
      end

      interface to character function tolower (c)
      character c
      end

      interface to logical function parse_str_def (str, opseq ,num)
      integer num
      character *256 str, opseq
      end

      interface to logical function is_digit (str)
      character str
      end


C #######################################################


C *********************************************************************
C *								      *
C *  Setxlt- decodes a string specifying a translation, 	      *
C *								      *
C *********************************************************************
      subroutine setxlt (xlt, xltpt, params)
      character*1024 xlt
      integer xltpt(0:256)
      character*256 params

      logical parse_str_def
      character*256 rep
      character key
      integer num

      if( .NOT. parse_str_def(params, rep, num)) then
	call screen('Cannot understand key string\n'C,2)
	return
      end if
      if( num .NE. 1 )then
	call screen('Key string must be a single character\n'C,2)
	return
      end if
      key = rep(1:1)

      if( params(1:1) .NE. ':' ) then
	call screen('Strings must be separated by ":"\n'C,2)
	return
      end if
      params = params(2:)

      if( .NOT. parse_str_def(params, rep, num) )then
	call screen('Cannot understand replacement string\n'C,2)
	return
      end if

      call screen('From 'C,2)
      call screscstr(key,1,2)
      call screen(' to 'C,2)
      call screscstr(rep,num,2)
      call screen('\n'C,2)

      call setxltlow (xlt, xltpt, key, rep, num)

      end

C *********************************************************************
C *								      *
C *  Setxltlow- set the translation specified			      *
C *								      *
C *********************************************************************
      subroutine setxltlow ( xlt, xltpt, key, rep, replen)
      character*1024 xlt
      integer xltpt(0:256)
      character key
      character *(*) rep
      integer replen

      integer k,dlen,i
      character *256 tmp

      k = ichar(key)
C     change in length of storage
      dlen = replen - ( xltpt(k+1) - xltpt(k) )

      if( (xltpt(256) + dlen) .GT. 1024)then
	call screen('Not enough space for that translation\n'C,
     +		    2)
	return
      end if

      if(dlen .NE. 0)then
C	Move table up/down to make/take up space
	tmp = xlt(xltpt(k+1):xltpt(256))
	xlt(xltpt(k+1)+dlen:xltpt(256)+dlen) = tmp

C	Alter pointers
	do i=k+1,256
	  xltpt(i) = xltpt(i)+dlen
	end do
      end if

C     Write in new representation
      do i=1, replen
	xlt(xltpt(k)+i-1:xltpt(k)+i-1) = rep(i:i)
      end do
      end

C *********************************************************************
C *								      *
C *   Set_com- reads input string for the name of a port. Also looks  *
C *   for names of form 'COMn' and uses 'n' to set comno	      *
C *								      *
C *								      *
C *********************************************************************
      subroutine set_com( name )
      character*256 name

C Port parameters definition common data
      integer*1 comno,baud,parity,databits,stopbits,brk
      common /port/ comno,baud,parity,databits,stopbits,brk
C Port name
      character*8 comname
      common /port/ comname

      logical is_digit

      integer i,len

      call dropspace( name )
      len = scan(name,char(0)) - 1
      if( len .EQ. 0 )then
	call screen('Port is '//comname//'\n'C,2)
	return
      end if

      if( scan(name,' ') .NE. 0 )
     +	len = min(len, scan(name,' ') - 1 )

      if(len .GT. 8)then
	call screen('Device name to long- truncating\n'C,2)
	name(9:9) = char(0)
	len = 8
      end if

      close (1)
      close (2)

C     Convert to upper case
      do i=1,len
	if( (name(i:i) .GE. 'a') .AND.
     +	    (name(i:i) .LE. 'z')      )
     +	      name(i:i) = char( ichar(name(i:i)) - 32 )
      end do

      read(name(1:len),'(A8)') comname
      if(name(1:3) .EQ. 'COM')then
C     attempt to decode 'n' part of 'COMn'
	if( is_digit(name(4:4)) )then
	  if( is_digit(name(5:5)) )then
C	    Is two-digit number
	    read(name(4:5),'(I2)') comno
	    if( (comno .GE. 1) .AND. (comno .LE. 16)
     +		.AND. (len .EQ. 5) )then
	      comno = comno - 1
	    else
	      comno = -1
	    end if
	  else
C	    Is one-digit number
	    read(name(4:4),'(I1)') comno
	    if( (comno .GE. 1) .AND. (comno .LE. 16)
     +		.AND. (len .EQ. 4) )then
	      comno = comno - 1
	    else
	      comno = -1
	    end if
	  end if
	else
	  comno = -1
	end if
      else
	comno = -1
      end if

      call open_com

      call screen('New port is '//comname//'\n'C,2)

      end

C *********************************************************************
C *								      *
C *   Help- displays help information				      *
C *								      *
C *********************************************************************
      subroutine help
      call screen(
     +'Function keys:                          '//
     +'                                        '//
     +' F1             help                    '//
     +' F10            quit                    '//
     +' F2             setup                   '//
     +'                                        '//
     +'Type ALT-C (ie press "C" while "alt" key'//
     +' is held down) to issue command.        '//
     +'Commands are:                           '//
     +' H              help                    '//
     +' Q              quit                    '//
     +' E{n|s|l|s}     set echo screen, line   '//
     +' C<portname>    set port (e.g. COM2)    '//
     +' B<Baudrate>    set Baud rate           '//
     +' P{n|o|e|m|s}   set parity              '//
     +' I<char>:<strn> translate input         '//
     +' O<char>:<strn> translate output        '//
     +' X<filename>    execute file            '//
     +' R<Command...>  run DOS command         '//
     +' T<srtn>        transmit sequence       '//
     +' ''              comment                 '//
     +'                                        '//
     +' ( <char> is a decimal number or a chara'//
     +'cter in quotation marks.                '//
     +'   <strn> is a sequence of numbers & quo'//
     +'ted strings separated by commas,        '//
     +'   Eg O 12:12,"New page",13,10          '//
     +'                                  )\n'C, 2)


      end

C *********************************************************************
C *								      *
C *  Set_parity -scans input string for a parity letter, any of	      *
C *  n,N (none), o,O (odd), e,E (even), m,M (mark), s,S (space).      *
C *  Subsequent characters are ignored				      *
C *								      *
C *********************************************************************
      subroutine set_parity( param )
      character*256 param
C Port parameters definition common data
      integer*1 comno,baud,parity,databits,stopbits,brk
      common /port/ comno,baud,parity,databits,stopbits,brk
C Port name
      character*8 comname
      common /port/ comname
C Names of parity settings.
      character*5 parys(0:4)
      common /parysc/ parys

      logical BIOS_x_init
      character tolower

      integer*1 p

      p = scan('noems',tolower(param))
      if(p .GT. 0)then
	p = p - 1
	if( BIOS_x_init(comno,brk,p,stopbits,databits,baud))then
	  parity = p
	  call screen('Parity set to '//parys(parity)//'\n'C,2)
	else
	 call screen('Cannot set that parity\n'C,2)
	end if
      else
	if( param(1:1) .EQ. char(0) )then
	  call screen('Parity is '//parys(parity)//'\n'C,2)
	else
	  call screen('Bad parity specification\n'C,2)
	end if
      end if
      end

C *********************************************************************
C *								      *
C *  Set_echo -operands are letters-any combination of l, s and n     *
C *  in upper or lower case. S indicates echo to screen, l indicates  *
C *  echo to serial line and n indicates no echo.		      *
C *  The later characters of contradictory settings are used.	      *
C *  No parameters switches off both echos.			      *
C *								      *
C *********************************************************************
      subroutine set_echo ( param )
      character*256 param

C terminal data common
      logical echol,echos
      common /term/ echol,echos

      character tolower

      integer pt

      echol = .FALSE.
      echos = .FALSE.
      pt = 1
      do while( param(pt:pt) .NE. char(0) )
	select case (tolower(param(pt:pt)))
	  case('n')
	    echol = .FALSE.
	    echos = .FALSE.
	  case('l')
	    echol = .TRUE.
	  case('s')
	    echos = .TRUE.
	  case(' ')
	  case default
	    call screen('Unrecognised character in echo setting\n'C,2)
	end select
	pt = pt + 1
      end do

      if( echol )then
	if( echos )then
	  call screen('Echo set to screen and line\n'C,2)
	else
	  call screen('Echo set to line only\n'C,2)
	end if
      else
	if( echos )then
	  call screen('Echo set to screen only\n'C,2)
	else
	  call screen('No echo set\n'C,2)
	end if
      end if
      end


C *********************************************************************
C *								      *
C *  Set_baud-scans parameter for a valid baud rate. Sets	      *
C *  port.							      *
C *								      *
C *********************************************************************
      subroutine set_baud(param)
      character*256 param

C Port parameters definition common data
      integer*1 comno,baud,parity,databits,stopbits,brk
      common /port/ comno,baud,parity,databits,stopbits,brk
C Port name
      character*8 comname
      common /port/ comname
C Names for bauds rates
      integer bauds(0:11)
      common /baudsc/ bauds

      integer baudsyns(52) /110,11,0,
     +			    150,15,0,
     +			    300,30,0,
     +			    600,60,0,
     +			    1200,120,12,0,
     +			    2400,240,24,0,
     +			    4800,480,48,0,
     +			    9600,960,96,0,
     +			    19200,1920,192,19,0,
     +			    38400,3840,384,38,0,
     +			    56000,5600,560,56,57600,5760,576,57,0,
     +			    115200,11520,1152,115,0/

      logical BIOS_x_init

      integer i,num
      character*6 tmp
      integer*1 bd,count

      if( param(1:1) .NE. char(0) )then

        num = verify(param,'0123456789')
        do i=num,6
          param(i:i) = ' '
        end do

	read(param,'(I6)') num
	bd = -1
	count = 0
C	Find a matching Baud rate synonymn
	do i=1,52
	  if( baudsyns(i) .EQ. 0 ) count = count + 1
	  if( baudsyns(i) .EQ. num ) bd = count
	end do

	if( BIOS_x_init(comno,brk,parity,stopbits,
     +			databits,bd) )then
	  baud = bd
	  write(tmp,'(I6)') bauds(baud)
	  call screen('Baud rate set to '//tmp//'\n'C,2)
	else
	  call screen('Cannot set that Baud rate\n'C,2)
	end if
      else
	write(tmp,'(I6)') bauds(baud)
	call screen('Baud rate is '//tmp//'\n'C,2)
      end if

      end


C *********************************************************************
C *								      *
C *  Exec_file-opens file with name as its parameters, reads lines    *
C *  from it and executes these as commands.			      *
C *								      *
C *								      *
C *********************************************************************
      subroutine exec_file(name)
      character*256 name

C Internal variables common
      integer nextunit
      common /intvar/ nextunit

      integer io
      character*256 line

      call dropspace(name)
      open(nextunit, file=name, iostat=io, status='OLD')

      if( io .EQ. 0 )then
	call screen('Executing file '//name,2)
	call screen('\n'C,2)

	do while( .TRUE. )
	  read (nextunit,'(A)',err=100) line
	  io = len_trim(line) + 1
	  line(io:io) = char(0)
	  call dropspace(line)
	  nextunit = nextunit + 1
	  call cmdout(line)
	  nextunit = nextunit - 1
	end do
  100	continue
	close(nextunit)

	call screen('Executing file terminated\n'C,2)
      else
	call screen('Could not open file '//name,2)
	call screen('\n'C,2)
      end if

      end
