1000 'GW BASIC BIOS interface test program
1010 'GW BASIC code fragment to set COM1 to 1200 Baud,
1020 :
1030 DEFINT A-Z
1040 :
1050 GOSUB 5000       'Set up machine code
1060 :
1080 AX = &H9A       'Service 0, initialise
1090                   'Parameters as above
1100 DX = &H0          'COM1
1110 BX = 0
1115 CX = 0
1120 DEF SEG
1130 ADDR = VARPTR(ASM%(0))
1140 CALL ADDR(AX,BX,CX,DX)    'Call interupt with these values
1150 :
1160 END
2000 'GW BASIC BIOS interface test program
2010 'GW BASIC code fragment to send a character to COM2
2030 DEFINT A-Z
2040 :
2050 GOSUB 5000       'Set up machine code
2060 :
2070 NEXTCHAR$ = "a"
2080 AX = CVI(NEXTCHAR$+CHR$(&H1))
2090                   'Service 1H, send character
2100 DX = &H1          'COM2
2110 BX = 0            'Must always create these
2115 CX = 0
2120 DEF SEG
2130 ADDR = VARPTR(ASM%(0))
2140 CALL ADDR(AX,BX,CX,DX)    'Call interrupt with these values
2150 :
2160 AL = AX AND 255            'Get at byte registers
2170 AH = ASC(RIGHT$(MKI$(AX),1))
2180 :
2190 IF AH AND &H80 THEN PRINT "COM2 timed out on output":END
2200 :
2210 END
3000 'GW BASIC code fragment to set addresses for
3010 'COM3 and COM4
3020 :
3030 DEFINT A-Z         'Parameters are integers
3040 :
3050 GOSUB 5000         'Set up machine code
3060 :
3070 COM3ADDR = &H3220
3080 COM4ADDR = &H3228
3090 :
3100 AX = &HAD00        'Service ADH, set address
3110 BX = COM3ADDR      'New address
3120 CX = 0             'Must create
3130 DX = &H2          'COM3
3140 :
3150 DEF SEG
3160 ADDR = VARPTR(ASM%(0))
3170 CALL ADDR(AX,BX,CX,DX)     'Call interrupt
3180 :
3190 IF AX <> &H52AD THEN PRINT "NewBIOS not installed!" :END
3200 :
3300 AX = &HAD00
3400 BX = COM4ADDR
3410 DX = &H3          'COM4
3420 :
3440 ADDR = VARPTR(ASM%(0))
3450 CALL ADDR(AX,BX,CX,DX)
3460 :
3470 END
5000 'BIOS interface setup
5010 :
5020 DIM ASM%(23)                'Array to hold data
5030 :
5040 :
5050 TOT# = 0          'Data check
5060 RESTORE 5230
5070 :
5080 FOR I = 0 TO 21
5090   READ S$, T$                   'read in data
5100   ASM%(I) = VAL("&H" + T$ + S$)
5110   TOT# = TOT# + ASM%(I)
5120 NEXT I
5130 :
5140 IF TOT# = -144845! THEN 5190
5150 PRINT "Bad machine code data, terminating program."
5160 PRINT "Check data statements at lines 27520 to 27710"
5170 END
5180 :
5190 RETURN
5200 :
5210 '8086 machine code. Moves values in operands to chip registers,
5220 'performs INT 14H, and copies the registers back to the variables.
5230 DATA 55                  : 'PUSH BP
5240 DATA 8B,EC               : 'MOV BP,SP
5250 DATA 8B,76,0C            : 'MOV SI,[BP]+0CH
5260 DATA 8B,04               : 'MOV AX,[SI]
5270 DATA 8B,76,0A            : 'MOV SI,[BP]+0AH
5280 DATA 8B,1C               : 'MOV BX,[SI]
5290 DATA 8B,76,08            : 'MOV SI,[BP]+8
5300 DATA 8B,0C               : 'MOV CX,[SI]
5310 DATA 8B,7E,06            : 'MOV DI,[BP]+6
5320 DATA 8B,15               : 'MOV DX,[DI]
5330 DATA CD,14               : 'INT 14h
5340 DATA 89,15               : 'MOV [DI],DX
5350 DATA 89,0C               : 'MOV [SI],CX
5360 DATA 8B,76,0A            : 'MOV SI,[BP]+0AH
5370 DATA 89,1C               : 'MOV [si]+8,BX
5380 DATA 8B,76,0C            : 'MOV SI,[BP]+0CH
5390 DATA 89,04               : 'MOV [si]+6,AX
5400 DATA 5D                  : 'POP BP
5410 DATA CA,08,00            : 'RETF 8
5420 DATA 00
